<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8"/>
    <title>eval.ml &mdash; Coverage report</title>
    <meta name="description" content="100.00% coverage in lib/eval.ml">
    <link rel="stylesheet" href="../coverage.css"/>
    <script src="../highlight.pack.js"></script>
    <script>hljs.initHighlightingOnLoad();</script>
  </head>
  <body>
    <div id="header">
      <h1>
        <a href="../index.html">
          <span class="dirname">lib/</span>eval.ml
        </a>
      </h1>
      <h2>100.00%</h2>
    </div>
    <div id="navbar">
    </div>
    <div id="report">
      <div id="lines-layer">
        <pre>
<a id="L1"></a><span > </span>
<a id="L2"></a><span > </span>
<a id="L3"></a><span > </span>
<a id="L4"></a><span > </span>
<a id="L5"></a><span class="visited"> </span>
<a id="L6"></a><span > </span>
<a id="L7"></a><span class="visited"> </span>
<a id="L8"></a><span class="visited"> </span>
<a id="L9"></a><span class="visited"> </span>
<a id="L10"></a><span class="visited"> </span>
<a id="L11"></a><span class="visited"> </span>
<a id="L12"></a><span class="visited"> </span>
<a id="L13"></a><span class="visited"> </span>
<a id="L14"></a><span class="visited"> </span>
<a id="L15"></a><span class="visited"> </span>
<a id="L16"></a><span > </span>
<a id="L17"></a><span class="visited"> </span>
<a id="L18"></a><span > </span>
<a id="L19"></a><span class="visited"> </span>
<a id="L20"></a><span class="visited"> </span>
<a id="L21"></a><span > </span>
<a id="L22"></a><span class="visited"> </span>
<a id="L23"></a><span class="visited"> </span>
<a id="L24"></a><span class="visited"> </span>
<a id="L25"></a><span class="visited"> </span>
<a id="L26"></a><span class="visited"> </span>
<a id="L27"></a><span > </span>
<a id="L28"></a><span > </span>
<a id="L29"></a><span > </span>
<a id="L30"></a><span > </span>
<a id="L31"></a><span > </span>
<a id="L32"></a><span > </span>
<a id="L33"></a><span > </span>
<a id="L34"></a><span > </span>
<a id="L35"></a><span > </span>
<a id="L36"></a><span > </span>
<a id="L37"></a><span > </span>
<a id="L38"></a><span class="visited"> </span>
<a id="L39"></a><span class="visited"> </span>
<a id="L40"></a><span class="visited"> </span>
<a id="L41"></a><span class="visited"> </span>
<a id="L42"></a><span class="visited"> </span>
<a id="L43"></a><span class="visited"> </span>
<a id="L44"></a><span > </span>
<a id="L45"></a><span > </span>
<a id="L46"></a><span > </span>
<a id="L47"></a><span class="visited"> </span>
<a id="L48"></a><span > </span>
<a id="L49"></a><span > </span>
<a id="L50"></a><span class="visited"> </span>
<a id="L51"></a><span > </span>
<a id="L52"></a><span class="visited"> </span>
<a id="L53"></a><span class="visited"> </span>
<a id="L54"></a><span class="visited"> </span>
<a id="L55"></a><span class="visited"> </span>
<a id="L56"></a><span class="visited"> </span>
<a id="L57"></a><span class="visited"> </span>
<a id="L58"></a><span class="visited"> </span>
<a id="L59"></a><span class="visited"> </span>
<a id="L60"></a><span > </span>
<a id="L61"></a><span class="visited"> </span>
<a id="L62"></a><span > </span>
<a id="L63"></a><span class="visited"> </span>
<a id="L64"></a><span class="visited"> </span>
<a id="L65"></a><span class="visited"> </span>
<a id="L66"></a><span > </span>
<a id="L67"></a><span class="visited"> </span>
<a id="L68"></a><span class="visited"> </span>
<a id="L69"></a><span class="visited"> </span>
<a id="L70"></a><span > </span>
<a id="L71"></a><span class="visited"> </span>
<a id="L72"></a><span class="visited"> </span>
<a id="L73"></a><span class="visited"> </span>
<a id="L74"></a><span > </span>
<a id="L75"></a><span class="visited"> </span>
<a id="L76"></a><span class="visited"> </span>
<a id="L77"></a><span class="visited"> </span>
<a id="L78"></a><span > </span>
<a id="L79"></a><span class="visited"> </span>
<a id="L80"></a><span > </span>
<a id="L81"></a><span class="visited"> </span>
<a id="L82"></a><span > </span>
<a id="L83"></a><span > </span>
<a id="L84"></a><span > </span>
<a id="L85"></a><span class="visited"> </span>
</pre>
      </div>
      <div id="text-layer">
        <pre id="line-numbers">
<a href="#L1"> 1</a>
<a href="#L2"> 2</a>
<a href="#L3"> 3</a>
<a href="#L4"> 4</a>
<a href="#L5"> 5</a>
<a href="#L6"> 6</a>
<a href="#L7"> 7</a>
<a href="#L8"> 8</a>
<a href="#L9"> 9</a>
<a href="#L10">10</a>
<a href="#L11">11</a>
<a href="#L12">12</a>
<a href="#L13">13</a>
<a href="#L14">14</a>
<a href="#L15">15</a>
<a href="#L16">16</a>
<a href="#L17">17</a>
<a href="#L18">18</a>
<a href="#L19">19</a>
<a href="#L20">20</a>
<a href="#L21">21</a>
<a href="#L22">22</a>
<a href="#L23">23</a>
<a href="#L24">24</a>
<a href="#L25">25</a>
<a href="#L26">26</a>
<a href="#L27">27</a>
<a href="#L28">28</a>
<a href="#L29">29</a>
<a href="#L30">30</a>
<a href="#L31">31</a>
<a href="#L32">32</a>
<a href="#L33">33</a>
<a href="#L34">34</a>
<a href="#L35">35</a>
<a href="#L36">36</a>
<a href="#L37">37</a>
<a href="#L38">38</a>
<a href="#L39">39</a>
<a href="#L40">40</a>
<a href="#L41">41</a>
<a href="#L42">42</a>
<a href="#L43">43</a>
<a href="#L44">44</a>
<a href="#L45">45</a>
<a href="#L46">46</a>
<a href="#L47">47</a>
<a href="#L48">48</a>
<a href="#L49">49</a>
<a href="#L50">50</a>
<a href="#L51">51</a>
<a href="#L52">52</a>
<a href="#L53">53</a>
<a href="#L54">54</a>
<a href="#L55">55</a>
<a href="#L56">56</a>
<a href="#L57">57</a>
<a href="#L58">58</a>
<a href="#L59">59</a>
<a href="#L60">60</a>
<a href="#L61">61</a>
<a href="#L62">62</a>
<a href="#L63">63</a>
<a href="#L64">64</a>
<a href="#L65">65</a>
<a href="#L66">66</a>
<a href="#L67">67</a>
<a href="#L68">68</a>
<a href="#L69">69</a>
<a href="#L70">70</a>
<a href="#L71">71</a>
<a href="#L72">72</a>
<a href="#L73">73</a>
<a href="#L74">74</a>
<a href="#L75">75</a>
<a href="#L76">76</a>
<a href="#L77">77</a>
<a href="#L78">78</a>
<a href="#L79">79</a>
<a href="#L80">80</a>
<a href="#L81">81</a>
<a href="#L82">82</a>
<a href="#L83">83</a>
<a href="#L84">84</a>
<a href="#L85">85</a>
</pre>
<pre><code class="ocaml">open! Core
open! Ast

let rec alpha_equal t1 t2 =
  <span data-count="6166541">l</span>et open Term in
  match t1, t2 with
  | <span data-count="3935435">V</span>ar var1, Var var2 -&gt; Var.equal var1 var2
  | <span data-count="53">I</span>nl { val_ = t11; type_ = t12 }, Inl { val_ = t21; type_ = t22 }
  | <span data-count="49">I</span>nr { val_ = t11; type_ = t12 }, Inr { val_ = t21; type_ = t22 }
  | <span data-count="51">P</span>air { fst = t11; snd = t12 }, Pair { fst = t21; snd = t22 }
  | <span data-count="79">S</span>um { left = t11; right = t12 }, Sum { left = t21; right = t22 }
  | <span data-count="78">P</span>rod { left = t11; right = t12 }, Prod { left = t21; right = t22 }
  | <span data-count="354464">A</span>pp { fun_ = t11; arg = t12 }, App { fun_ = t21; arg = t22 } -&gt;
    alpha_equa<span data-count="354774">l</span> t11 t21 &amp;&amp; <span data-count="354773">a</span>lpha_equal t12 t22
  | <span data-count="18324">(</span> Fun { binder = var1, annot1; body = body1 }
    , Fun { binder = var2, annot2; body = body2 } )
  | <span data-count="959218">(</span> Pi { binder = var1, annot1; type_ = body1 }
    , Pi { binder = var2, annot2; type_ = body2 } ) -&gt;
    alpha_equa<span data-count="977542">l</span> annot1 annot2 &amp;&amp; <span data-count="977540">a</span>lpha_equal body1 (subst_va<span data-count="977540">r</span> ~var:var2 ~var':var1 body2)
  | <span data-count="36">(</span> Let { binder = var1, annot1; val_ = val1; in_ = in1 }
    , Let { binder = var2, annot2; val_ = val2; in_ = in2 } ) -&gt;
    alpha_equa<span data-count="36">l</span> annot1 annot2
    &amp;&amp; <span data-count="36">a</span>lpha_equa<span data-count="36">l</span> val1 val2
    &amp;&amp; <span data-count="36">a</span>lpha_equal in1 (subst_va<span data-count="36">r</span> ~var:var2 ~var':var1 in2)
  | <span data-count="46">F</span>st t1, Fst t2 | <span data-count="43">S</span>nd t1, Snd t2 -&gt; alpha_equal t1 t2
  | <span data-count="54">(</span> Match
        { matchee = matchee1
        ; inl = inl_var1, inl_body1
        ; inr = inr_var1, inr_body1
        ; type_ = type1
        }
    , Match
        { matchee = matchee2
        ; inl = inl_var2, inl_body2
        ; inr = inr_var2, inr_body2
        ; type_ = type2
        } ) -&gt;
    alpha_equa<span data-count="54">l</span> matchee1 matchee2
    &amp;&amp; <span data-count="54">a</span>lpha_equa<span data-count="54">l</span> inl_body1 (subst_va<span data-count="54">r</span> ~var:inl_var2 ~var':inl_var1 inl_body2)
    &amp;&amp; <span data-count="54">a</span>lpha_equa<span data-count="54">l</span> inr_body1 (subst_va<span data-count="54">r</span> ~var:inr_var2 ~var':inr_var1 inr_body2)
    &amp;&amp; <span data-count="54">a</span>lpha_equal type1 type2
  | <span data-count="898571">K</span>ind kind1, Kind kind2 -&gt; Kind.equal kind1 kind2
  | <span data-count="40">_</span>, _ -&gt; false
;;

let rec eval term =
  <span data-count="251226937">l</span>et open Term in
  match term with
  (* Non-reducable *)
  | <span data-count="118180855">V</span>ar _ | <span data-count="21582882">K</span>ind _ -&gt; term
  (* Introduction forms *)
  | <span data-count="5405009">F</span>un { binder = var, type_; body } -&gt;
    Fun { binder = var, eva<span data-count="5405009">l</span> type_; body = eva<span data-count="5405009">l</span> body }
  | <span data-count="13874737">P</span>i { binder = var, kind; type_ } -&gt; Pi { binder = var, eva<span data-count="13874737">l</span> kind; type_ = eva<span data-count="13874737">l</span> type_ }
  | <span data-count="197">P</span>rod { left; right } -&gt; Prod { left = eva<span data-count="197">l</span> left; right = eva<span data-count="197">l</span> right }
  | <span data-count="199">S</span>um { left; right } -&gt; Sum { left = eva<span data-count="199">l</span> left; right = eva<span data-count="199">l</span> right }
  | <span data-count="171">P</span>air { fst; snd } -&gt; Pair { fst = eva<span data-count="171">l</span> fst; snd = eva<span data-count="171">l</span> snd }
  | <span data-count="151">I</span>nl { val_; type_ } -&gt; Inl { val_ = eva<span data-count="151">l</span> val_; type_ = eva<span data-count="151">l</span> type_ }
  | <span data-count="159">I</span>nr { val_; type_ } -&gt; Inr { val_ = eva<span data-count="159">l</span> val_; type_ = eva<span data-count="159">l</span> type_ }
  (* Elimination forms *)
  | <span data-count="92182012">A</span>pp { fun_; arg } -&gt;
    (match eval fun_ with
    | <span data-count="2566453">F</span>un { binder = var, _; body } -&gt; eval (subs<span data-count="2566453">t</span> ~var ~term:arg body)
    | <span data-count="89615559">f</span>un_ -&gt; App { fun_; arg = eva<span data-count="89615559">l</span> arg })
  | <span data-count="140">F</span>st t -&gt;
    (match eval t with
    | <span data-count="7">P</span>air { fst; _ } -&gt; fst
    | <span data-count="133">t</span> -&gt; Fst t)
  | <span data-count="137">S</span>nd t -&gt;
    (match eval t with
    | <span data-count="9">P</span>air { snd; _ } -&gt; snd
    | <span data-count="128">t</span> -&gt; Snd t)
  | <span data-count="167">M</span>atch { matchee; inl = varl, bodyl; inr = varr, bodyr; type_ } -&gt;
    (match eval matchee with
    | <span data-count="11">I</span>nl { val_ = arg; _ } -&gt; eval (subs<span data-count="11">t</span> ~var:varl ~term:arg bodyl)
    | <span data-count="5">I</span>nr { val_ = arg; _ } -&gt; eval (subs<span data-count="5">t</span> ~var:varr ~term:arg bodyr)
    | <span data-count="151">m</span>atchee -&gt;
      Match
        { matchee; inl = varl, eva<span data-count="151">l</span> bodyl; inr = varr, eva<span data-count="151">l</span> bodyr; type_ = eva<span data-count="151">l</span> type_ })
  (* Let form *)
  | <span data-count="121">L</span>et { binder; val_; in_ } -&gt;
    eval (App { fun_ = Fun { binder; body = in_ }; arg = val_ })
;;

let beta_equal t1 t2 = <span data-count="3501469">a</span>lpha_equal (eva<span data-count="3501469">l</span> t1) (eva<span data-count="3501469">l</span> t2)
</code></pre>
      </div>
    </div>
    <script src="../coverage.js"></script>
  </body>
</html>
